searchData={"items":[{"type":"module","title":"AlipayKit","doc":"A kit for Alipay.\n\n> This package is built by following my proposal -\n> [Ship utilities for building platform SDKs](https://github.com/cozy-elixir/proposals/blob/main/ship-utilities-for-building-platform-sdks.md).","ref":"AlipayKit.html"},{"type":"module","title":"AlipayKit.Legacy","doc":"A kit for Alipay legacy API.\n\n> I don't know what they named this API because that part of the\n> documentation is a bit confusing. Let's call it \"legacy\".\n\n> Although the OpenAPI V3 is released, some features are still retained in\n> the legacy API.","ref":"AlipayKit.Legacy.html"},{"type":"module","title":"Endpoints - AlipayKit.Legacy","doc":"* Production: `\"https://openapi.alipay.com/gateway.do\"`\n  * Sandbox: `\"https://openapi-sandbox.dl.alipaydev.com/gateway.do\"`","ref":"AlipayKit.Legacy.html#module-endpoints"},{"type":"module","title":"Methods for signing - AlipayKit.Legacy","doc":"Alipay officially supports two methods:\n\n  * Keys (密钥)\n  * Certificates (证书)\n\nBut, this module only supports **Keys** method for now.","ref":"AlipayKit.Legacy.html#module-methods-for-signing"},{"type":"module","title":"Explore available API - AlipayKit.Legacy","doc":"Visit  .","ref":"AlipayKit.Legacy.html#module-explore-available-api"},{"type":"module","title":"Usage - AlipayKit.Legacy","doc":"","ref":"AlipayKit.Legacy.html#module-usage"},{"type":"module","title":"Build signed params for mobile SDK - AlipayKit.Legacy","doc":"Just build a signed params, and pass it to the mobile SDK.","ref":"AlipayKit.Legacy.html#module-build-signed-params-for-mobile-sdk"},{"type":"module","title":"Build a signed params and send it via an HTTP request - AlipayKit.Legacy","doc":"1. build a signed params with `sign_params!/2`.\n  2. send the signed params to a particular endpoint:\n     - with a POST request\n     - or, with a GET request\n\nAssuming we use the Production environment, then sending a GET request should\nbe like this:\n\n```text\nGET /gateway.do?  HTTP/1.1\nHost: openapi.alipay.com\n```\n\nSending a POST request should be like this:\n\n```text\nPOST /gateway.do HTTP/1.1\nHost: openapi.alipay.com\nContent-Type: application/x-www-form-urlencoded; charset=UTF-8\n\n \n```\n\n> #### Warning {: .warning}\n>\n> Don't miss the `Content-Type` header when sending POST request, or the Alipay\n> will sent a bad response back.","ref":"AlipayKit.Legacy.html#module-build-a-signed-params-and-send-it-via-an-http-request"},{"type":"module","title":"More - AlipayKit.Legacy","doc":"I don't want to repeat what the official documentation already covers. For\nmore information, please refer to the following materials:\n\n  * [支付宝 Legacy API](https://opendocs.alipay.com/common/02nebq)","ref":"AlipayKit.Legacy.html#module-more"},{"type":"function","title":"AlipayKit.Legacy.sign_params!/2","doc":"Signs params.","ref":"AlipayKit.Legacy.html#sign_params!/2"},{"type":"function","title":"Examples - AlipayKit.Legacy.sign_params!/2","doc":"params = %{\n      app_id: \"your app id\",\n      method: \"alipay.trade.pay\",\n      biz_content: %{\n        out_trade_no: \"70501111111S001111119\",\n        total_amount: \"9.00\",\n        subject: \"Fresh air\"\n      }\n    }\n\n    opts = [app_private_key: \"your app private key\"]\n\n    AlipayKit.Legacy.sign_params!(params, opts)","ref":"AlipayKit.Legacy.html#sign_params!/2-examples"},{"type":"function","title":"References - AlipayKit.Legacy.sign_params!/2","doc":"* [自行实现签名](https://opendocs.alipay.com/common/057k53)","ref":"AlipayKit.Legacy.html#sign_params!/2-references"},{"type":"function","title":"AlipayKit.Legacy.verify_notification/2","doc":"Verifies a notification request issued by Alipay, and returns the verified\npayload.","ref":"AlipayKit.Legacy.html#verify_notification/2"},{"type":"function","title":"Examples - AlipayKit.Legacy.verify_notification/2","doc":"// send a request to Alipay service, and you'll get a notification request\n    request = HTTPSpec.Request.new!([\n      query: \"...\",\n      // ...\n    ])\n\n    AlipayKit.Legacy.verify_notification(request, [\n      alipay_public_key: \"your alipay public key\"\n    ])\n\nIf you can get the params, you can use it directly:\n\n    params = %{\n      \"sign_type\" => \"RSA2\",\n      \"sign\" => \"...\",\n      # ...\n    }\n\n    AlipayKit.Legacy.verify_notification(params, [\n      alipay_public_key: \"your alipay public key\"\n    ])","ref":"AlipayKit.Legacy.html#verify_notification/2-examples"},{"type":"function","title":"References - AlipayKit.Legacy.verify_notification/2","doc":"* [自行实现验签](https://opendocs.alipay.com/common/02mse7)","ref":"AlipayKit.Legacy.html#verify_notification/2-references"},{"type":"function","title":"AlipayKit.Legacy.verify_response/2","doc":"Verifies a response returned by Alipay, and returns the verified and decoded\n`*_response` section of body.","ref":"AlipayKit.Legacy.html#verify_response/2"},{"type":"function","title":"Examples - AlipayKit.Legacy.verify_response/2","doc":"// send a request to Alipay service, and get a response\n    response = HTTPSpec.Response.new!([\n      body: \"...\",\n      // ...\n    ])\n\n    AlipayKit.Legacy.verify_response(response, [\n      alipay_public_key: \"your alipay public key\"\n    ])","ref":"AlipayKit.Legacy.html#verify_response/2-examples"},{"type":"function","title":"References - AlipayKit.Legacy.verify_response/2","doc":"* [自行实现验签](https://opendocs.alipay.com/common/02mse7)","ref":"AlipayKit.Legacy.html#verify_response/2-references"},{"type":"type","title":"AlipayKit.Legacy.alipay_public_key/0","doc":"The Alipay's public key in PEM format, such as:\n\n```\n-----BEGIN PUBLIC KEY-----\nMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAlHcsKzSFSoYkHionHPwo\n \n-----END PUBLIC KEY-----\n```","ref":"AlipayKit.Legacy.html#t:alipay_public_key/0"},{"type":"type","title":"AlipayKit.Legacy.app_id/0","doc":"","ref":"AlipayKit.Legacy.html#t:app_id/0"},{"type":"type","title":"AlipayKit.Legacy.app_private_key/0","doc":"The app's RSA private key in PEM format, such as:\n\n```\n-----BEGIN RSA PRIVATE KEY-----\nMIIEowIBAAKCAQEAlHcsKzSFSoYkHionHPwocwlgpX1iS9Fg+ZadVZMHiKrXvHUW\n \n-----END RSA PRIVATE KEY-----\n```\n\nor:\n\n```\n-----BEGIN PRIVATE KEY-----\nMIIEowIBAAKCAQEAlHcsKzSFSoYkHionHPwocwlgpX1iS9Fg+ZadVZMHiKrXvHUW\n \n-----END PRIVATE KEY-----\n```","ref":"AlipayKit.Legacy.html#t:app_private_key/0"},{"type":"type","title":"AlipayKit.Legacy.biz_content/0","doc":"","ref":"AlipayKit.Legacy.html#t:biz_content/0"},{"type":"type","title":"AlipayKit.Legacy.charset/0","doc":"","ref":"AlipayKit.Legacy.html#t:charset/0"},{"type":"type","title":"AlipayKit.Legacy.format/0","doc":"","ref":"AlipayKit.Legacy.html#t:format/0"},{"type":"type","title":"AlipayKit.Legacy.method/0","doc":"","ref":"AlipayKit.Legacy.html#t:method/0"},{"type":"type","title":"AlipayKit.Legacy.notify_url/0","doc":"","ref":"AlipayKit.Legacy.html#t:notify_url/0"},{"type":"type","title":"AlipayKit.Legacy.sign_params/0","doc":"The params will be signed.","ref":"AlipayKit.Legacy.html#t:sign_params/0"},{"type":"type","title":"Limitations - AlipayKit.Legacy.sign_params/0","doc":"* `app_auth_token` is not supported.","ref":"AlipayKit.Legacy.html#t:sign_params/0-limitations"},{"type":"type","title":"AlipayKit.Legacy.sign_params_opt/0","doc":"","ref":"AlipayKit.Legacy.html#t:sign_params_opt/0"},{"type":"type","title":"AlipayKit.Legacy.sign_params_opts/0","doc":"","ref":"AlipayKit.Legacy.html#t:sign_params_opts/0"},{"type":"type","title":"AlipayKit.Legacy.sign_type/0","doc":"","ref":"AlipayKit.Legacy.html#t:sign_type/0"},{"type":"type","title":"AlipayKit.Legacy.timestamp/0","doc":"","ref":"AlipayKit.Legacy.html#t:timestamp/0"},{"type":"type","title":"AlipayKit.Legacy.verify_notification_opt/0","doc":"","ref":"AlipayKit.Legacy.html#t:verify_notification_opt/0"},{"type":"type","title":"AlipayKit.Legacy.verify_notification_opts/0","doc":"","ref":"AlipayKit.Legacy.html#t:verify_notification_opts/0"},{"type":"type","title":"AlipayKit.Legacy.verify_response_opt/0","doc":"","ref":"AlipayKit.Legacy.html#t:verify_response_opt/0"},{"type":"type","title":"AlipayKit.Legacy.verify_response_opts/0","doc":"","ref":"AlipayKit.Legacy.html#t:verify_response_opts/0"},{"type":"type","title":"AlipayKit.Legacy.version/0","doc":"","ref":"AlipayKit.Legacy.html#t:version/0"},{"type":"module","title":"AlipayKit.V3","doc":"A kit for Alipay OpenAPI V3.","ref":"AlipayKit.V3.html"},{"type":"module","title":"Endpoints - AlipayKit.V3","doc":"* Production: `\"https://openapi.alipay.com/v3\"`\n  * Sandbox: `\"https://openapi-sandbox.dl.alipaydev.com/v3\"`","ref":"AlipayKit.V3.html#module-endpoints"},{"type":"module","title":"Methods for signing - AlipayKit.V3","doc":"Alipay officially supports two methods:\n\n  * Keys (密钥)\n  * Certificates (证书)\n\nBut, this module only supports **Keys** method for now.","ref":"AlipayKit.V3.html#module-methods-for-signing"},{"type":"module","title":"Explore available API - AlipayKit.V3","doc":"Visit  .","ref":"AlipayKit.V3.html#module-explore-available-api"},{"type":"module","title":"Usage - AlipayKit.V3","doc":"","ref":"AlipayKit.V3.html#module-usage"},{"type":"module","title":"Build a signed request and send it via an HTTP request - AlipayKit.V3","doc":"1. build a `%HTTPSpec.Request{}`.\n  2. sign the request with `sign_request!/2`.\n  3. send the requset.\n\nWhen building the request, don't forget adding required headers:\n\n```text\nContent-Type: application/json; charset=UTF-8\nAccept: application/json\n```\n\nAnd it's better to add a header for request id:\n\n```text\nalipay-request-id: <32 characters>\n```","ref":"AlipayKit.V3.html#module-build-a-signed-request-and-send-it-via-an-http-request"},{"type":"module","title":"More - AlipayKit.V3","doc":"I don't want to repeat what the official documentation already covers. For\nmore information, please refer to the following materials:\n\n  * [支付宝 OpenAPI V3](https://opendocs.alipay.com/open-v3/053sd1)","ref":"AlipayKit.V3.html#module-more"},{"type":"function","title":"AlipayKit.V3.sign_request!/2","doc":"Signs a request.","ref":"AlipayKit.V3.html#sign_request!/2"},{"type":"function","title":"Examples - AlipayKit.V3.sign_request!/2","doc":"","ref":"AlipayKit.V3.html#sign_request!/2-examples"},{"type":"function","title":"References - AlipayKit.V3.sign_request!/2","doc":"* [支付宝 OpenAPI V3 - 签名规则](https://opendocs.alipay.com/open-v3/054q58)","ref":"AlipayKit.V3.html#sign_request!/2-references"},{"type":"function","title":"AlipayKit.V3.verify_response/2","doc":"Verifies a response returned by Alipay, and returns the verified and decoded body.","ref":"AlipayKit.V3.html#verify_response/2"},{"type":"function","title":"References - AlipayKit.V3.verify_response/2","doc":"* [支付宝 OpenAPI V3 - 验签规则](https://opendocs.alipay.com/open-v3/054d0z)","ref":"AlipayKit.V3.html#verify_response/2-references"},{"type":"type","title":"AlipayKit.V3.alipay_public_key/0","doc":"The Alipay's public key in PEM format, such as:\n\n```\n-----BEGIN PUBLIC KEY-----\nMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAlHcsKzSFSoYkHionHPwo\n \n-----END PUBLIC KEY-----\n```","ref":"AlipayKit.V3.html#t:alipay_public_key/0"},{"type":"type","title":"AlipayKit.V3.app_id/0","doc":"","ref":"AlipayKit.V3.html#t:app_id/0"},{"type":"type","title":"AlipayKit.V3.app_private_key/0","doc":"The app's RSA private key in PEM format, such as:\n\n```\n-----BEGIN RSA PRIVATE KEY-----\nMIIEowIBAAKCAQEAlHcsKzSFSoYkHionHPwocwlgpX1iS9Fg+ZadVZMHiKrXvHUW\n \n-----END RSA PRIVATE KEY-----\n```\n\nor:\n\n```\n-----BEGIN PRIVATE KEY-----\nMIIEowIBAAKCAQEAlHcsKzSFSoYkHionHPwocwlgpX1iS9Fg+ZadVZMHiKrXvHUW\n \n-----END PRIVATE KEY-----\n```","ref":"AlipayKit.V3.html#t:app_private_key/0"},{"type":"type","title":"AlipayKit.V3.nonce/0","doc":"","ref":"AlipayKit.V3.html#t:nonce/0"},{"type":"type","title":"AlipayKit.V3.sign_request_opt/0","doc":"","ref":"AlipayKit.V3.html#t:sign_request_opt/0"},{"type":"type","title":"AlipayKit.V3.sign_request_opts/0","doc":"","ref":"AlipayKit.V3.html#t:sign_request_opts/0"},{"type":"type","title":"AlipayKit.V3.sign_type/0","doc":"","ref":"AlipayKit.V3.html#t:sign_type/0"},{"type":"type","title":"AlipayKit.V3.timestamp/0","doc":"","ref":"AlipayKit.V3.html#t:timestamp/0"},{"type":"type","title":"AlipayKit.V3.verify_response_opt/0","doc":"","ref":"AlipayKit.V3.html#t:verify_response_opt/0"},{"type":"type","title":"AlipayKit.V3.verify_response_opts/0","doc":"","ref":"AlipayKit.V3.html#t:verify_response_opts/0"},{"type":"extras","title":"AlipayKit","doc":"# AlipayKit\n\n[![CI](https://github.com/cozy-elixir/alipay_kit/actions/workflows/ci.yml/badge.svg)](https://github.com/cozy-elixir/alipay_kit/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/alipay_kit.svg)](https://hex.pm/packages/alipay_kit)\n\nA kit for Alipay.","ref":"readme.html"},{"type":"extras","title":"Features - AlipayKit","doc":"- Not tightly coupled with a specific HTTP client (Built on top of [http_spec](https://hex.pm/packages/http_spec))\n- Only includes basic signing and signature verification functions","ref":"readme.html#features"},{"type":"extras","title":"Installation - AlipayKit","doc":"Add `:alipay_kit` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:alipay_kit,  }\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AlipayKit","doc":"For more information, see the [documentation](https://hexdocs.pm/alipay_kit).","ref":"readme.html#usage"},{"type":"extras","title":"License - AlipayKit","doc":"[Apache License 2.0](https://www.apache.org/licenses/LICENSE-2.0)","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v1.0.0 - Changelog","doc":"- upgrade http_spec to v3.0.0","ref":"changelog.html#v1-0-0"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"- change return value of `AlipayKit.V3.verify_response/2` from `{:ok, map()} | {:error, :bad_response | :bad_signature}` to `:ok | {:error, :bad_response | :bad_signature}`","ref":"changelog.html#v0-3-0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}